%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                  %
%    DAEdalon Finite-Element-Project                               %
%                                                                  %
%    Copyright 2002/2003 Steffen Eckert/Oliver Goy                 %
%    Contact: http://www.daedalon.org                              %
%                                                                  %
%                                                                  %
%    This file is part of DAEdalon.                                %
%                                                                  %
%    DAEdalon is free software; you can redistribute it            %
%    and/or modify it under the terms of the GNU General           %
%    Public License as published by the Free Software Foundation;  %
%    either version 2 of the License, or (at your option)          %
%    any later version.                                            %
%                                                                  %
%    DAEdalon is distributed in the hope that it will be           %
%    useful, but WITHOUT ANY WARRANTY; without even the            %
%    implied warranty of MERCHANTABILITY or FITNESS FOR A          %
%    PARTICULAR PURPOSE.  See the GNU General Public License       %
%    for more details.                                             %
%                                                                  %
%    You should have received a copy of the GNU General            %
%    Public License along with Foobar; if not, write to the        %
%    Free Software Foundation, Inc., 59 Temple Place, Suite 330,   %
%    Boston, MA  02111-1307  USA                                   %
%                                                                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function cont_sm(arg1,arg2)
global numel aktele cont_value elem_nr cont_flag ndm;
global  surf_value surf_data elem_nr_matr el2mat;
global nummat mat2el;

cont_value = arg1;
mat_set = arg2;

% evalin ruft mfiles auf, wobei alle Variablen gltig sind, die auch
% im workspace verfgbar sind

% Aufruf von daestiff, durch setzen von mat_set = arg2 werden aber
% nur die Elemente mit Materialdatensatz mat_set assembliert
evalin('base','stiffness;');


% Vektor mit Contour-Variable aufbauen:
% eine zeile aus der Matrix cont_mat_node:
%    2-D:   (numnp x (epsx,epsy,2.0*epsxy,sigx,sigy,sigxy,,,))
%    3-D:   (numnp x (epsx,epsy,epsz,2.0*epsxy,2.0*epsyz,2.0*epsxz,
%                     sigx,sigy,sigz,sigxy,sigyz,sigxz,,,))

evalin('base','surf_data=cont_mat_node(:,[cont_value]);');

% Schleife ber alle Elemente EINES Datensatzes
listlength = mat2el(1,arg2);
elements = mat2el( 2:listlength+1,arg2);
for aktele = elements'

  % aufbereiten der Daten frs Element
  evalin('base','surfnodes');
  
  % Elementnummer bestimmen
  elem_nr=elem_nr_matr(el2mat(aktele));
  
  % Element zeichnen
  switch elem_nr
  case {2,3,4,6,8,13,14,23,24,26,33,36,39,86,87}
      evalin('base','patch(x_surf,y_surf,surf_value)');
      
      
  case {10}   % Stabelement
      % surf_value auf max. Strichstrke von 8 normieren
      surf_value = surf_value/max(abs(surf_data))*8.0;
        
      if surf_value >= 0.0 
         pl_col = 'r';
      else
         pl_col = 'b';
      end %if

     string = ['plot3(x_surf,y_surf,z_surf,''',pl_col, ...
             ''',''LineWidth'',',num2str(abs(surf_value)),')'];
     evalin('base', string);    
 
   
  case {7,11}    % Volumenelemente
      if elem_nr == 7   % Tetraederelement
        anz_f = 4;
      elseif elem_nr == 11   % Quaderelement
        anz_f = 6;
      end %if
       
     for k=1:anz_f
        fuckstring = ['patch(''Vertices'',[x_surf,y_surf,z_surf],',...
		    '''Faces'',face_surf(',num2str(k),',:),'...
		    '''FaceVertexCData'',surf_value,'...
		    '''FaceColor'',''interp'')'];
        evalin('base',fuckstring);
     end %for
        
  end %switch elem_nr
end %aktele

cont_max = max(surf_data);
cont_min = min(surf_data);

set(findobj('Type','patch'),'EdgeColor','none')

colorbar;
colormap(jet); % jet,bone,hsv

title(['cont(',num2str(cont_value),'):   ','max-Wert: ', ...
       num2str(cont_max),',   min-Wert: ',num2str(cont_min)]);

% Achsenbeschriftung
xlabel('x');
ylabel('y');
if (ndm==3)
  zlabel('z');
end

% nochmal aufrufen mit Schleife ber alle Materialdatenstze, damit
% alles wieder beim alten ist.
mat_set=1:nummat;
evalin('base','stiffness;');