%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                  %
%    DAEdalon Finite-Element-Project                               %
%                                                                  %
%    Copyright 2002/2003 Steffen Eckert                            %
%    Contact: http://www.daedalon.org                              %
%                                                                  %
%                                                                  %
%    This file is part of DAEdalon.                                %
%                                                                  %
%    DAEdalon is free software; you can redistribute it            %
%    and/or modify it under the terms of the GNU General           %
%    Public License as published by the Free Software Foundation;  %
%    either version 2 of the License, or (at your option)          %
%    any later version.                                            %
%                                                                  %
%    DAEdalon is distributed in the hope that it will be           %
%    useful, but WITHOUT ANY WARRANTY; without even the            %
%    implied warranty of MERCHANTABILITY or FITNESS FOR A          %
%    PARTICULAR PURPOSE.  See the GNU General Public License       %
%    for more details.                                             %
%                                                                  %
%    You should have received a copy of the GNU General            %
%    Public License along with Foobar; if not, write to the        %
%    Free Software Foundation, Inc., 59 Temple Place, Suite 330,   %
%    Boston, MA  02111-1307  USA                                   %
%                                                                  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% syst.m
% Einbau der Verschiebungsrandbedingungen in k
% und Aufbau der rechten Seite aus Lastvektor und Residuum

% Schleife ber alle vorgegebenen Randverschiebungen (in displ abgelegt)
% Zeile komplett ausnullen nur an der Stelle pos eine 1


% Faktor bestimmen mit dem die Randverschiebungen skaliert werden
if (load_flag==1)
  loadfactor = loadfunc(tim);
else
  loadfactor = 1;
end

% rechte Seite, zusammengesetzt aus Randlasten p und Residuum r
rhs = -r + loadfactor*p;
%kk=k;
for i=1:displ_len                   % Schleife ueber alle Randverschiebungen
    pos=ndf*(displ_node(i)-1)+displ_df(i); % globale Position im GlSyst 
    k(pos,:) = 0.0;                 % Zeile nullen
    k(:,pos)=0.0;                   % Spalte nullen
    k(pos,pos)= 1.0;                % 1 auf (i,i)-Position
    rhs(pos)=0.0;                   % Verschiebungsinkrement=0 eintragen
end  %i

% Die Verschiebungsrandbed werden in stiffness in u( ) eingetragen,
% sodass die Inkremente delta_u immer = 0 sind

% Ende syst.m
